#ifndef RENJU_H
#define RENJU_H

#include "gomoku.h"
#include "lists.h"

class Choice:public ReadWriteStringList {
protected:
	const char *Name(void) { return "choice"; };
};

class Renju: public Gomoku {
protected:
	Choice choice;
	enum MoveType { ILLEGAL=-1, LEGAL, FORBIDDEN, WINNING };
	int IsSymmetric(int row1, int col1, int row2, int col2);

	static int RowDelta[];
	static int ColDelta[];

	virtual MoveType CheckMove(int row, int col, int Whosturn, int level=0);
	virtual void CollectRows(int row, int col, int d, int quantity[],int level);
	virtual void Collect56(int row, int col, int d, int quantity[], int *found,int level);
	virtual void Collect4(int row, int col, int d, int quantity[], int *found,int level);
	virtual void Collect3(int row, int col, int d, int quantity[], int *found,int level);
public:

	virtual const char *PlayerNames(int n) { return "Eks\0Ohs"+n*4; }
	virtual const char PlayerPieces(int n) { return "xo"[n]; }

	virtual int ReadBoard(GameFile &game);
	virtual int WriteBoard(GameFile &game);

	virtual const char *MakeMove(const char *move);
	virtual int MustSkip(void);
	virtual const char *ForcedMove(void);
	virtual int IsGameOver(const char *&winner);
	virtual int Init(void);	

// Non-board specific
	virtual const char *GameType(void) { return "Renju"; }
	virtual int MoveWidth(void) { return 7; }
	virtual int SwapAfterMove(void) { return 1; }
	virtual int CanPass() { return 1; };

	virtual int NagTime(void);
	virtual int ForfeitTime(void);

	virtual int TotalTimeAllowed(void);
};

#endif
